/*
 * NodeComparisonAmendDialog.java
 *
 * Created on December 21, 2001, 11:28 PM
 */

package fina2.metadata;

import java.awt.GridBagConstraints;
import java.util.Collection;
import java.util.Vector;

import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import javax.swing.DefaultComboBoxModel;

import fina2.Main;
import fina2.javascript.Wizard;
import fina2.ui.UIManager;
import fina2.ui.table.EJBTable;
import fina2.ui.table.TableRow;

public class NodeComparisonAmendDialog extends javax.swing.JDialog {

	private fina2.ui.UIManager ui = fina2.Main.main.ui;
	private Collection refNodes;
	private Wizard wizard;
	private TableRow tableRow;
	private EJBTable table;
	private int tableRowIndex;
	private boolean canAmend;

	public NodeComparisonAmendDialog(EJBTable table, TableRow tableRow,
			int tableRowIndex, java.awt.Frame parent, boolean modal) {

		super(parent, modal);
		this.table = table;
		this.tableRow = tableRow;
		this.tableRowIndex = tableRowIndex;

		ui.loadIcon("fina2.cancel", "cancel.gif");
		ui.loadIcon("fina2.help", "help.gif");
		ui.loadIcon("fina2.ok", "ok.gif");

		ui.loadIcon("fina2.amend", "amend.gif");

		initComponents();
		Vector v = new Vector();

		v.add("=");
		v.add("<>");
		v.add(">");
		v.add(">=");
		v.add("<");
		v.add("<=");

		conditionList.setModel(new DefaultComboBoxModel(v));

	}

	public void setVisible(boolean v) {

		if ((v) && (wizard != null)) {
			refNodes = wizard.getRefNodes();
			if (refNodes != null) {
				scriptText.setText(wizard.getSource());
			}
			wizard = null;
		}
		super.setVisible(v);
	}

	public String getCondition() {
		return String.valueOf(conditionList.getSelectedItem()).trim();
	}

	public String getEquation() {
		return scriptText.getText().trim();
	}

	public void show(String code, String condition, String equation,
			boolean canAmend) {

		codeText.setText(code);
		scriptText.setText(equation);
		conditionList.setSelectedItem(condition);
		conditionList.setEnabled(canAmend);
		scriptButton.setEnabled(canAmend);
		setLocationRelativeTo(getParent());
		this.canAmend = canAmend;
		super.show();
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	private void initComponents() {// GEN-BEGIN:initComponents
		jPanel1 = new javax.swing.JPanel();
		jPanel2 = new javax.swing.JPanel();
		jPanel3 = new javax.swing.JPanel();
		helpButton = new javax.swing.JButton();
		jPanel4 = new javax.swing.JPanel();
		OkButton = new javax.swing.JButton();
		CancelButton = new javax.swing.JButton();
		jPanel5 = new javax.swing.JPanel();
		jPanel11 = new javax.swing.JPanel();
		jLabel1 = new javax.swing.JLabel();
		codeText = new javax.swing.JTextField();
		jLabel2 = new javax.swing.JLabel();
		conditionList = new javax.swing.JComboBox();
		jPanel6 = new javax.swing.JPanel();
		scrollPane = new javax.swing.JScrollPane();
		scriptText = new javax.swing.JTextArea();
		jPanel7 = new javax.swing.JPanel();
		scriptButton = new javax.swing.JButton();

		setTitle(ui.getString("fina2.metadata.comparisonrules"));
		setFont(ui.getFont());
		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent evt) {
				closeDialog(evt);
			}
		});

		jPanel1.setLayout(new java.awt.BorderLayout());

		jPanel2.setLayout(new java.awt.BorderLayout());

		helpButton.setIcon(ui.getIcon("fina2.help"));
		helpButton.setFont(ui.getFont());
		helpButton.setText(ui.getString("fina2.help"));
		helpButton.setEnabled(false);
		jPanel3.add(helpButton);

		jPanel2.add(jPanel3, java.awt.BorderLayout.WEST);

		OkButton.setIcon(ui.getIcon("fina2.ok"));
		OkButton.setFont(ui.getFont());
		OkButton.setText(ui.getString("fina2.ok"));
		OkButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				OkButtonActionPerformed(evt);
			}
		});

		jPanel4.add(OkButton);

		CancelButton.setIcon(ui.getIcon("fina2.cancel"));
		CancelButton.setFont(ui.getFont());
		CancelButton.setText(ui.getString("fina2.cancel"));
		CancelButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				CancelButtonActionPerformed(evt);
			}
		});

		jPanel4.add(CancelButton);

		jPanel2.add(jPanel4, java.awt.BorderLayout.EAST);

		jPanel1.add(jPanel2, java.awt.BorderLayout.SOUTH);

		jPanel5.setLayout(new java.awt.BorderLayout());

		jPanel5.setBorder(new javax.swing.border.EtchedBorder());
		jPanel11.setLayout(new java.awt.GridBagLayout());

		jLabel1.setText(ui.getString("fina2.code"));
		jLabel1.setFont(ui.getFont());
		jPanel11.add(jLabel1, UIManager.getGridBagConstraints(0, 0, -1, -1, -1,
				-1, GridBagConstraints.EAST, -1,
				new java.awt.Insets(5, 0, 0, 5)));

		codeText.setEditable(false);
		codeText.setColumns(16);
		codeText.setFont(ui.getFont());
		jPanel11.add(codeText, UIManager.getGridBagConstraints(1, 0, -1, -1,
				-1, -1, GridBagConstraints.WEST, -1, new java.awt.Insets(5, 0,
						0, 0)));

		jLabel2.setText(ui.getString("fina2.condition"));
		jLabel2.setFont(ui.getFont());
		jPanel11.add(jLabel2, UIManager.getGridBagConstraints(0, 1, -1, -1, -1,
				-1, GridBagConstraints.EAST, -1,
				new java.awt.Insets(5, 0, 5, 5)));

		conditionList.setFont(ui.getFont());
		jPanel11.add(conditionList, UIManager.getGridBagConstraints(1, 1, -1,
				-1, -1, -1, GridBagConstraints.WEST, -1, new java.awt.Insets(5,
						0, 5, 0)));

		jPanel5.add(jPanel11, java.awt.BorderLayout.NORTH);

		jPanel6.setLayout(new java.awt.BorderLayout());

		scrollPane.setPreferredSize(new java.awt.Dimension(400, 200));
		scriptText.setEditable(false);
		scriptText.setFont(ui.getFont());
		scriptText.setEnabled(false);
		scrollPane.setViewportView(scriptText);

		jPanel6.add(scrollPane, java.awt.BorderLayout.CENTER);

		scriptButton.setIcon(ui.getIcon("fina2.amend"));
		scriptButton.setFont(ui.getFont());
		scriptButton.setText(ui.getString("fina2.metadata.amendequation"));
		scriptButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				scriptButtonActionPerformed(evt);
			}
		});

		jPanel7.add(scriptButton);

		jPanel6.add(jPanel7, java.awt.BorderLayout.SOUTH);

		jPanel5.add(jPanel6, java.awt.BorderLayout.SOUTH);

		jPanel1.add(jPanel5, java.awt.BorderLayout.CENTER);

		getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

		pack();
	}// GEN-END:initComponents

	private void scriptButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN
		// -
		// FIRST
		// :
		// event_scriptButtonActionPerformed
		wizard = new fina2.javascript.Wizard(this, scriptText.getText());
		wizard.show();
	}// GEN-LAST:event_scriptButtonActionPerformed

	private void CancelButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN
		// -
		// FIRST
		// :
		// event_CancelButtonActionPerformed
		dispose();
	}// GEN-LAST:event_CancelButtonActionPerformed

	private void OkButtonActionPerformed(java.awt.event.ActionEvent evt) { //GEN-
		// FIRST
		// :
		// event_OkButtonActionPerformed

		if (canAmend) {

			tableRow.setValue(1, getCondition());
			tableRow.setValue(2, getEquation());

			try {
				InitialContext jndi = fina2.Main.getJndiContext();

				Object ref = jndi.lookup("fina2/metadata/MDTSession");
				MDTSessionHome sessionHome = (MDTSessionHome) PortableRemoteObject
						.narrow(ref, MDTSessionHome.class);

				MDTSession session = sessionHome.create();

				session.setComparison(tableRow);
				table.updateRow(tableRowIndex, tableRow);

			} catch (Exception e) {
				Main.generalErrorHandler(e);
			}
		}

		dispose();
	} // GEN-LAST:event_OkButtonActionPerformed

	/** Closes the dialog */
	private void closeDialog(java.awt.event.WindowEvent evt) {// GEN-FIRST:
		// event_closeDialog
		setVisible(false);
		dispose();
	}// GEN-LAST:event_closeDialog

	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JPanel jPanel1;
	private javax.swing.JPanel jPanel2;
	private javax.swing.JPanel jPanel3;
	private javax.swing.JButton helpButton;
	private javax.swing.JPanel jPanel4;
	private javax.swing.JButton OkButton;
	private javax.swing.JButton CancelButton;
	private javax.swing.JPanel jPanel5;
	private javax.swing.JPanel jPanel11;
	private javax.swing.JLabel jLabel1;
	private javax.swing.JTextField codeText;
	private javax.swing.JLabel jLabel2;
	private javax.swing.JComboBox conditionList;
	private javax.swing.JPanel jPanel6;
	private javax.swing.JScrollPane scrollPane;
	private javax.swing.JTextArea scriptText;
	private javax.swing.JPanel jPanel7;
	private javax.swing.JButton scriptButton;
	// End of variables declaration//GEN-END:variables

}
