/*
 * PeriodAmendDialog.java
 *
 * Created on October 31, 2001, 3:05 AM
 */

package fina2.period;

import java.awt.GridBagConstraints;
import java.util.Vector;

import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import javax.swing.DefaultComboBoxModel;
import javax.transaction.UserTransaction;

import fina2.Main;
import fina2.ui.UIManager;
import fina2.ui.table.EJBTable;
import fina2.ui.table.TableRow;
import fina2.ui.table.TableRowImpl;

/**
 * 
 * @author vasop
 */
public class PeriodAmendDialog extends javax.swing.JDialog {

	private fina2.ui.UIManager ui = fina2.Main.main.ui;
	private fina2.Main main = fina2.Main.main;

	private PeriodTypeSelectDialog periodTypeSelectDialog;

	private EJBTable table;
	private TableRow tableRow;
	private Period period;
	private PeriodTypePK typePK;

	/** Creates new form PeriodAmendDialog */
	public PeriodAmendDialog(java.awt.Frame parent, boolean modal) {
		super(parent, modal);

		ui.loadIcon("fina2.cancel", "cancel.gif");
		ui.loadIcon("fina2.help", "help.gif");
		ui.loadIcon("fina2.ok", "ok.gif");

		ui.loadIcon("fina2.find", "find.gif");

		periodTypeSelectDialog = new PeriodTypeSelectDialog(parent, true);

		initComponents();
		typeList.setModel(new DefaultComboBoxModel(getTypeNames()));
	}

	public TableRow getTableRow() {
		return tableRow;
	}

	public void show(TableRow tableRow, boolean canAmend) {
		this.tableRow = tableRow;
		// periodTypeText.setEditable(canAmend);
		periodNumberText.setEditable(canAmend);
		fromDateText.setEditable(canAmend);
		toDateText.setEditable(canAmend);
		period = null;
		if (tableRow != null) {

			PeriodPK pk = (PeriodPK) tableRow.getPrimaryKey();

			try {
				InitialContext jndi = fina2.Main.getJndiContext();

				Object ref = jndi.lookup("fina2/period/Period");
				PeriodHome home = (PeriodHome) PortableRemoteObject.narrow(ref, PeriodHome.class);

				period = home.findByPrimaryKey(pk);

				ref = jndi.lookup("fina2/period/PeriodType");
				PeriodTypeHome typeHome = (PeriodTypeHome) PortableRemoteObject.narrow(ref, PeriodTypeHome.class);

				typePK = period.getType();
				PeriodType periodType = typeHome.findByPrimaryKey(typePK);

				periodNumberText.setText(period.getPeriodNumber());
				fromDateText.setText(period.getFromDate(main.getLanguageHandle()));
				toDateText.setText(period.getToDate(main.getLanguageHandle()));

			} catch (Exception e) {
				Main.generalErrorHandler(e);
				return;
			}
		}
		setLocationRelativeTo(getParent());
		show();
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	private void initComponents() {// GEN-BEGIN:initComponents
		jPanel1 = new javax.swing.JPanel();
		periodTypeLabel = new javax.swing.JLabel();
		periodNumberLabel = new javax.swing.JLabel();
		periodNumberText = new javax.swing.JTextField();
		fromDateLabel = new javax.swing.JLabel();
		fromDateText = new javax.swing.JTextField();
		toDateLabel = new javax.swing.JLabel();
		toDateText = new javax.swing.JTextField();
		jPanel2 = new javax.swing.JPanel();
		jPanel3 = new javax.swing.JPanel();
		helpButton = new javax.swing.JButton();
		jPanel4 = new javax.swing.JPanel();
		okButton = new javax.swing.JButton();
		cancelButton = new javax.swing.JButton();
		typeList = new javax.swing.JComboBox();

		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent evt) {
				closeDialog(evt);
			}
		});

		jPanel1.setLayout(new java.awt.GridBagLayout());

		jPanel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(30, 70, 30, 70)));
		periodTypeLabel.setText(UIManager.formatedHtmlString(ui.getString("fina2.period.periodType")));
		periodTypeLabel.setFont(ui.getFont());
		jPanel1.add(periodTypeLabel, UIManager.getGridBagConstraints(0, 0, 10, 10, -1, -1, GridBagConstraints.EAST, -1, null));

		typeList.setFont(ui.getFont());
		typeList.setPreferredSize(new java.awt.Dimension(150, 21));
		jPanel1.add(typeList, UIManager.getGridBagConstraints(1, 0, -1, -1, -1, -1, GridBagConstraints.WEST, -1, null));

		periodNumberLabel.setText(UIManager.formatedHtmlString(ui.getString("fina2.period.periodNumber")));
		periodNumberLabel.setFont(ui.getFont());
		jPanel1.add(periodNumberLabel, UIManager.getGridBagConstraints(0, 1, 10, 10, -1, -1, GridBagConstraints.EAST, -1, null));

		periodNumberText.setFont(ui.getFont());
		periodNumberText.setPreferredSize(new java.awt.Dimension(50, 21));
		jPanel1.add(periodNumberText, UIManager.getGridBagConstraints(1, 1, -1, -1, -1, -1, GridBagConstraints.WEST, -1, null));

		fromDateLabel.setText(UIManager.formatedHtmlString(ui.getString("fina2.period.fromDate")));
		fromDateLabel.setFont(ui.getFont());
		jPanel1.add(fromDateLabel, UIManager.getGridBagConstraints(0, 2, 10, 10, -1, -1, GridBagConstraints.EAST, -1, null));

		fromDateText.setFont(ui.getFont());
		fromDateText.setPreferredSize(new java.awt.Dimension(70, 21));
		jPanel1.add(fromDateText, UIManager.getGridBagConstraints(1, 2, -1, -1, -1, -1, GridBagConstraints.WEST, -1, null));

		toDateLabel.setText(UIManager.formatedHtmlString(ui.getString("fina2.period.toDate")));
		toDateLabel.setFont(ui.getFont());
		jPanel1.add(toDateLabel, UIManager.getGridBagConstraints(0, 3, 10, 10, -1, -1, GridBagConstraints.EAST, -1, null));

		toDateText.setFont(ui.getFont());
		toDateText.setPreferredSize(new java.awt.Dimension(70, 21));
		jPanel1.add(toDateText, UIManager.getGridBagConstraints(1, 3, -1, -1, -1, -1, GridBagConstraints.WEST, -1, null));

		getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

		jPanel2.setLayout(new java.awt.BorderLayout());

		helpButton.setIcon(ui.getIcon("fina2.help"));
		helpButton.setFont(ui.getFont());
		helpButton.setText(ui.getString("fina2.help"));
		helpButton.setEnabled(false);
		helpButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				helpButtonActionPerformed(evt);
			}
		});

		jPanel3.add(helpButton);

		jPanel2.add(jPanel3, java.awt.BorderLayout.WEST);

		okButton.setIcon(ui.getIcon("fina2.ok"));
		okButton.setFont(ui.getFont());
		okButton.setText(ui.getString("fina2.ok"));
		okButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				okButtonActionPerformed(evt);
			}
		});

		jPanel4.add(okButton);

		cancelButton.setIcon(ui.getIcon("fina2.cancel"));
		cancelButton.setFont(ui.getFont());
		cancelButton.setText(ui.getString("fina2.cancel"));
		cancelButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				cancelButtonActionPerformed(evt);
			}
		});

		jPanel4.add(cancelButton);

		jPanel2.add(jPanel4, java.awt.BorderLayout.EAST);

		getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);

		pack();
	}// GEN-END:initComponents

	/**
	 * @author Davit Beradze
	 * @return Vector with Period Session Type names
	 */
	private Vector getTypeNames() {
		Vector typeNames = new Vector();
		try {
			InitialContext jndi = fina2.Main.getJndiContext();
			Object ref = jndi.lookup("fina2/period/PeriodSession");
			PeriodSessionHome home = (PeriodSessionHome) PortableRemoteObject.narrow(ref, PeriodSessionHome.class);

			PeriodSession session = home.create();
			table = new EJBTable();

			table.initTable(typeNames, session.getPeriodTypeRows(main.getUserHandle(), main.getLanguageHandle()));
			if (table.getRowCount() > 1)
				tableRow = table.getTableRow(1);
			else
				tableRow = table.getTableRow(0);

			for (int i = 0; i < table.getRowCount(); i++) {
				TableRow row = table.getTableRow(i);
				typeNames.add(row.getValue(1));
			}

		} catch (Exception e) {
			Main.generalErrorHandler(e);
		}
		return typeNames;
	}

	private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN
		// -
		// FIRST
		// :
		// event_cancelButtonActionPerformed
		dispose();
	}// GEN-LAST:event_cancelButtonActionPerformed

	private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN-
		// FIRST
		// :
		// event_okButtonActionPerformed

		if (typePK == null)
			return;
		try {
			InitialContext jndi = fina2.Main.getJndiContext();
			Object ref = jndi.lookup("fina2/period/Period");
			PeriodHome home = (PeriodHome) PortableRemoteObject.narrow(ref, PeriodHome.class);

			try {
				if (period == null) {
					period = home.create();
				}
			} catch (Exception e) {
				if (tableRow == null)
					period = null;
				Main.generalErrorHandler(e);
				return;
			}
			UserTransaction trans = main.getUserTransaction(jndi);
			trans.begin();

			try {

				if (typePK != null)
					period.setType(typePK);
				period.setPeriodNumber(periodNumberText.getText());
				period.setFromDate(main.getLanguageHandle(), fromDateText.getText());
				period.setToDate(main.getLanguageHandle(), toDateText.getText());

				trans.commit();
			} catch (java.text.ParseException e) {
				Main.errorHandler(null, Main.getString("fina2.title"), Main.getString("fina2.invalidDateFormat"));
				trans.rollback();
				if (tableRow == null) {
					period.remove();
					period = null;
				}
				return;
			} catch (Exception e) {
				Main.generalErrorHandler(e);
				trans.rollback();
				if (tableRow == null) {
					period.remove();
					period = null;
				}
				return;
			}
			if (tableRow == null) {
				tableRow = new TableRowImpl(period.getPrimaryKey(), 4);
				if (typePK != null)
					tableRow.setValue(0, typeList.getSelectedItem().toString());
				else
					tableRow.setValue(0, "");
				tableRow.setValue(1, period.getPeriodNumber());
				tableRow.setValue(2, period.getFromDate(main.getLanguageHandle()));
				tableRow.setValue(3, period.getToDate(main.getLanguageHandle()));
			} else {
				if (typePK != null)
					tableRow.setValue(0, typeList.getSelectedItem().toString());
				else
					tableRow.setValue(0, "");
				tableRow.setValue(1, period.getPeriodNumber());
				tableRow.setValue(2, period.getFromDate(main.getLanguageHandle()));
				tableRow.setValue(3, period.getToDate(main.getLanguageHandle()));
			}
		} catch (Exception e) {
			Main.generalErrorHandler(e);
		}
		dispose();
	}// GEN-LAST:event_okButtonActionPerformed

	private void helpButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN
		// -
		// FIRST
		// :
		// event_helpButtonActionPerformed
		// Add your handling code here:
	}// GEN-LAST:event_helpButtonActionPerformed

	/** Closes the dialog */
	private void closeDialog(java.awt.event.WindowEvent evt) {// GEN-FIRST:
		// event_closeDialog
		setVisible(false);
		dispose();
	}// GEN-LAST:event_closeDialog

	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JPanel jPanel1;
	private javax.swing.JLabel periodTypeLabel;
	private javax.swing.JLabel periodNumberLabel;
	private javax.swing.JTextField periodNumberText;
	private javax.swing.JLabel fromDateLabel;
	private javax.swing.JTextField fromDateText;
	private javax.swing.JLabel toDateLabel;
	private javax.swing.JTextField toDateText;
	private javax.swing.JPanel jPanel2;
	private javax.swing.JPanel jPanel3;
	private javax.swing.JButton helpButton;
	private javax.swing.JPanel jPanel4;
	private javax.swing.JButton okButton;
	private javax.swing.JButton cancelButton;
	private javax.swing.JComboBox typeList;
	// End of variables declaration//GEN-END:variables

}
