/*
 * PeriodTypeDialog.java
 *
 * Created on October 26, 2001, 2:01 AM
 */

package fina2.period;

import java.awt.GridBagConstraints;

import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import javax.transaction.UserTransaction;

import fina2.Main;
import fina2.ui.UIManager;
import fina2.ui.table.TableRow;
import fina2.ui.table.TableRowImpl;

/**
 * 
 * @author vasop
 */
public class PeriodTypeAmendDialog extends javax.swing.JDialog {

	private fina2.ui.UIManager ui = fina2.Main.main.ui;
	private fina2.Main main = fina2.Main.main;

	private TableRow tableRow;
	private PeriodType periodType;

	/** Creates new form PeriodTypeDialog */
	public PeriodTypeAmendDialog(java.awt.Frame parent, boolean modal) {
		super(parent, modal);

		ui.loadIcon("fina2.cancel", "cancel.gif");
		ui.loadIcon("fina2.help", "help.gif");
		ui.loadIcon("fina2.ok", "ok.gif");

		initComponents();
	}

	public TableRow getTableRow() {
		return tableRow;
	}

	public void show(TableRow tableRow, boolean canAmend) {
		this.tableRow = tableRow;
		codeText.setEditable(canAmend);
		descriptionText.setEditable(canAmend);
		periodType = null;
		if (tableRow != null) {

			PeriodTypePK pk = (PeriodTypePK) tableRow.getPrimaryKey();

			try {
				InitialContext jndi = fina2.Main.getJndiContext();

				Object ref = jndi.lookup("fina2/period/PeriodType");
				PeriodTypeHome home = (PeriodTypeHome) PortableRemoteObject.narrow(ref, PeriodTypeHome.class);

				periodType = home.findByPrimaryKey(pk);

				codeText.setText(periodType.getCode());
				descriptionText.setText(periodType.getDescription(main.getLanguageHandle()));

			} catch (Exception e) {
				Main.generalErrorHandler(e);
				return;
			}
		}
		setLocationRelativeTo(getParent());
		show();
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	private void initComponents() {// GEN-BEGIN:initComponents

		jPanel1 = new javax.swing.JPanel();
		jLabel2 = new javax.swing.JLabel();
		codeText = new javax.swing.JTextField();
		jLabel3 = new javax.swing.JLabel();
		descriptionText = new javax.swing.JTextField();
		jPanel2 = new javax.swing.JPanel();
		jPanel3 = new javax.swing.JPanel();
		helpButton = new javax.swing.JButton();
		jPanel4 = new javax.swing.JPanel();
		okButton = new javax.swing.JButton();
		cancelButton = new javax.swing.JButton();

		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent evt) {
				closeDialog(evt);
			}
		});

		jPanel1.setLayout(new java.awt.GridBagLayout());

		jPanel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(30, 70, 30, 70)));
		jLabel2.setText(UIManager.formatedHtmlString(ui.getString("fina2.code")));
		jLabel2.setFont(ui.getFont());
		jPanel1.add(jLabel2, UIManager.getGridBagConstraints(0, 1, -1, -1, -1, -1, -1, -1, new java.awt.Insets(5, 0, 0, 0)));

		codeText.setFont(ui.getFont());
		codeText.setPreferredSize(new java.awt.Dimension(50, 21));
		jPanel1.add(codeText, UIManager.getGridBagConstraints(1, 1, -1, -1, -1, -1, GridBagConstraints.WEST, -1, new java.awt.Insets(5, 0, 0, 0)));

		jLabel3.setText(UIManager.formatedHtmlString(ui.getString("fina2.description")));
		jLabel3.setFont(ui.getFont());
		jPanel1.add(jLabel3, UIManager.getGridBagConstraints(0, 2, -1, -1, -1, -1, -1, -1, new java.awt.Insets(5, 0, 0, 0)));

		descriptionText.setFont(ui.getFont());
		descriptionText.setPreferredSize(new java.awt.Dimension(150, 21));
		jPanel1.add(descriptionText, UIManager.getGridBagConstraints(1, 2, -1, -1, -1, -1, GridBagConstraints.WEST, -1, new java.awt.Insets(5, 0, 0, 0)));

		getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

		jPanel2.setLayout(new java.awt.BorderLayout());

		helpButton.setIcon(ui.getIcon("fina2.help"));
		helpButton.setFont(ui.getFont());
		helpButton.setText(ui.getString("fina2.help"));
		helpButton.setEnabled(false);
		helpButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				helpButtonActionPerformed(evt);
			}
		});

		jPanel3.add(helpButton);

		jPanel2.add(jPanel3, java.awt.BorderLayout.WEST);

		okButton.setIcon(ui.getIcon("fina2.ok"));
		okButton.setFont(ui.getFont());
		okButton.setText(ui.getString("fina2.ok"));
		okButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				okButtonActionPerformed(evt);
			}
		});

		jPanel4.add(okButton);

		cancelButton.setIcon(ui.getIcon("fina2.cancel"));
		cancelButton.setFont(ui.getFont());
		cancelButton.setText(ui.getString("fina2.cancel"));
		cancelButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				cancelButtonActionPerformed(evt);
			}
		});

		jPanel4.add(cancelButton);

		jPanel2.add(jPanel4, java.awt.BorderLayout.EAST);

		getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);

		pack();
	}// GEN-END:initComponents

	private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN
		// -
		// FIRST
		// :
		// event_cancelButtonActionPerformed
		setVisible(false);
		dispose();
	}// GEN-LAST:event_cancelButtonActionPerformed

	// event_okButtonActionPerformed
	private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {
		// Code and Description validation
		if (!ui.isValidCode(codeText.getText())) {
			if (!ui.isValidLength(codeText.getText(), false)) {
				ui.showMessageBox(null, ui.getString("fina2.title"), ui.getString("fina2.web.banktype.code.length"));
				return;
			} else if (codeText.getText().length() == 0) {
				ui.showMessageBox(null, ui.getString("fina2.title"), ui.getString("fina2.definiton.code"));
				return;
			} else {

				ui.showMessageBox(null, ui.getString("fina2.title"), ui.getString("fina2.invalidCode"));
				return;
			}

		}
		if (!ui.isValidLength(descriptionText.getText(), true)) {
			ui.showMessageBox(null, ui.getString("fina2.title"), ui.getString("fina2.web.banktype.description.length255"));
			return;
		}
		if (descriptionText.getText().trim().equals("")) {
			ui.showMessageBox(null, ui.getString("fina2.title"), ui.getString("fina2.pleaseEnterDescription"));
			return;
		}
		try {
			InitialContext jndi = fina2.Main.getJndiContext();
			Object ref = jndi.lookup("fina2/period/PeriodType");
			PeriodTypeHome home = (PeriodTypeHome) PortableRemoteObject.narrow(ref, PeriodTypeHome.class);

			try {
				if (periodType == null) {
					periodType = home.create();
				}
			} catch (Exception e) {
				if (tableRow == null)
					periodType = null;
				Main.generalErrorHandler(e);
				return;
			}
			UserTransaction trans = main.getUserTransaction(jndi);
			trans.begin();

			try {
				// bankType.setCode(codeText.getText());
				periodType.setCode(codeText.getText());
				System.out.println("s" + codeText.getText());
				periodType.setDescription(main.getLanguageHandle(), descriptionText.getText());
				try {
					trans.commit();
				} catch (Exception tex) {
				}
			} catch (Exception e) {
				Main.generalErrorHandler(e);
				try {
					trans.rollback();
				} catch (Exception tex) {
				}
				if (tableRow == null) {
					periodType.remove();
					periodType = null;
				}
				return;
			}
			if (tableRow == null) {
				tableRow = new TableRowImpl(periodType.getPrimaryKey(), 2);
				tableRow.setValue(0, periodType.getCode());
				tableRow.setValue(1, periodType.getDescription(main.getLanguageHandle()));
			} else {
				tableRow.setValue(0, periodType.getCode());
				tableRow.setValue(1, periodType.getDescription(main.getLanguageHandle()));
			}
		} catch (Exception e) {
			Main.generalErrorHandler(e);
		}
		dispose();
	}// GEN-LAST:event_okButtonActionPerformed

	private void helpButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN
		// -
		// FIRST
		// :
		// event_helpButtonActionPerformed
		// Add your handling code here:
	}// GEN-LAST:event_helpButtonActionPerformed

	/** Closes the dialog */
	private void closeDialog(java.awt.event.WindowEvent evt) {// GEN-FIRST:
		// event_closeDialog
		setVisible(false);
		dispose();
	}// GEN-LAST:event_closeDialog

	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JButton cancelButton;
	private javax.swing.JTextField codeText;
	private javax.swing.JTextField descriptionText;
	private javax.swing.JButton helpButton;
	private javax.swing.JLabel jLabel2;
	private javax.swing.JLabel jLabel3;
	private javax.swing.JPanel jPanel1;
	private javax.swing.JPanel jPanel2;
	private javax.swing.JPanel jPanel3;
	private javax.swing.JPanel jPanel4;
	private javax.swing.JButton okButton;
	// End of variables declaration//GEN-END:variables

}
