/*
 * FormulaAmendDialog.java
 *
 * Created on 6  2002 ., 13:40
 */

package fina2.reportoo.repository;

import java.awt.GridBagConstraints;
import java.util.Iterator;
import java.util.Vector;

import fina2.ui.UIManager;

/**
 * 
 * @author Shota Shalamberidze
 */
public class FormulaAmendDialog extends javax.swing.JDialog {

	private fina2.ui.UIManager ui = fina2.Main.main.ui;
	private fina2.Main main = fina2.Main.main;

	private Formula formula;
	private Vector parameters;

	private boolean ok;

	/** Creates new form FormulaAmendDialog */
	public FormulaAmendDialog(java.awt.Frame parent, boolean modal) {
		super(parent, modal);

		ok = false;

		ui.loadIcon("fina2.new", "new.gif");
		ui.loadIcon("fina2.modify", "amend.gif");
		ui.loadIcon("fina2.delete", "delete.gif");
		ui.loadIcon("fina2.ok", "ok.gif");
		ui.loadIcon("fina2.cancel", "cancel.gif");
		ui.loadIcon("fina2.help", "help.gif");

		initComponents();

		jLabel7.setVisible(false);
		jScrollPane5.setVisible(false);

		jLabel4.setVisible(false);
		paramDescriptionText.setVisible(false);

		Vector v = new Vector(5);
		v.add(ui.getString("fina2.reportoo.parameterType.peerGroup"));
		v.add(ui.getString("fina2.reportoo.parameterType.offset"));
		v.add(ui.getString("fina2.reportoo.parameterType.period"));
		v.add(ui.getString("fina2.reportoo.parameterType.node"));
		v.add(ui.getString("fina2.reportoo.parameterType.banks"));
		paramTypeCombo.setModel(new javax.swing.DefaultComboBoxModel(new Vector(v)));

		formula = new Formula();
		setFormula(formula);
	}

	public boolean isOk() {
		return ok;
	}

	public void setFormula(Formula formula) {
		this.formula = formula;
		this.parameters = formula.getParameters();

		nameText.setText(formula.getName());
		descriptionText.setText(formula.getDescription());

		formulaText.setText(formula.getFormula());

		javax.swing.DefaultListModel m = new javax.swing.DefaultListModel();
		for (Iterator iter = parameters.iterator(); iter.hasNext();) {
			m.addElement(iter.next());
		}
		paramsList.setModel(m);
	}

	public Formula getFormula() {
		return formula;
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	private void initComponents() {// GEN-BEGIN:initComponents
		jPanel5 = new javax.swing.JPanel();
		jScrollPane2 = new javax.swing.JScrollPane();
		formulaText = new javax.swing.JTextArea();
		jPanel10 = new javax.swing.JPanel();
		jPanel12 = new javax.swing.JPanel();
		helpButton = new javax.swing.JButton();
		jPanel13 = new javax.swing.JPanel();
		okButton = new javax.swing.JButton();
		cancelButton = new javax.swing.JButton();
		jPanel14 = new javax.swing.JPanel();
		jPanel4 = new javax.swing.JPanel();
		jPanel7 = new javax.swing.JPanel();
		jScrollPane3 = new javax.swing.JScrollPane();
		paramsList = new javax.swing.JList();
		jLabel3 = new javax.swing.JLabel();
		paramNameText = new javax.swing.JTextField();
		jLabel4 = new javax.swing.JLabel();
		paramDescriptionText = new javax.swing.JTextField();
		jLabel8 = new javax.swing.JLabel();
		paramTypeCombo = new javax.swing.JComboBox();
		jPanel8 = new javax.swing.JPanel();
		jPanel9 = new javax.swing.JPanel();
		newButton = new javax.swing.JButton();
		modifyButton = new javax.swing.JButton();
		deleteButton = new javax.swing.JButton();
		jPanel15 = new javax.swing.JPanel();
		jLabel6 = new javax.swing.JLabel();
		nameText = new javax.swing.JTextField();
		jLabel7 = new javax.swing.JLabel();
		jScrollPane5 = new javax.swing.JScrollPane();
		descriptionText = new javax.swing.JTextArea();

		setTitle(ui.getString("fina2.reportoo.formula"));
		setResizable(false);
		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent evt) {
				closeDialog(evt);
			}
		});

		jPanel5.setLayout(new java.awt.BorderLayout());

		jPanel5.setBorder(new javax.swing.border.TitledBorder(null, ui.getString("fina2.reportoo.formula"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
				javax.swing.border.TitledBorder.DEFAULT_POSITION, ui.getFont()));
		formulaText.setWrapStyleWord(true);
		formulaText.setLineWrap(true);
		formulaText.setRows(7);
		formulaText.setFont(ui.getFont());
		jScrollPane2.setViewportView(formulaText);

		jPanel5.add(jScrollPane2, java.awt.BorderLayout.CENTER);

		getContentPane().add(jPanel5, java.awt.BorderLayout.CENTER);

		jPanel10.setLayout(new java.awt.BorderLayout());

		helpButton.setIcon(ui.getIcon("fina2.help"));
		helpButton.setFont(ui.getFont());
		helpButton.setText(ui.getString("fina2.help"));
		helpButton.setEnabled(false);
		jPanel12.add(helpButton);

		jPanel10.add(jPanel12, java.awt.BorderLayout.WEST);

		okButton.setIcon(ui.getIcon("fina2.ok"));
		okButton.setFont(ui.getFont());
		okButton.setText(ui.getString("fina2.ok"));
		okButton.setSelected(true);
		okButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				okButtonActionPerformed(evt);
			}
		});

		jPanel13.add(okButton);

		cancelButton.setIcon(ui.getIcon("fina2.cancel"));
		cancelButton.setFont(ui.getFont());
		cancelButton.setText(ui.getString("fina2.cancel"));
		cancelButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				cancelButtonActionPerformed(evt);
			}
		});

		jPanel13.add(cancelButton);

		jPanel10.add(jPanel13, java.awt.BorderLayout.EAST);

		getContentPane().add(jPanel10, java.awt.BorderLayout.SOUTH);

		jPanel14.setLayout(new java.awt.BorderLayout());

		jPanel4.setLayout(new java.awt.BorderLayout());

		jPanel4.setBorder(new javax.swing.border.TitledBorder(null, ui.getString("fina2.reportoo.parameters"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
				javax.swing.border.TitledBorder.DEFAULT_POSITION, ui.getFont()));
		jPanel7.setLayout(new java.awt.GridBagLayout());

		paramsList.setFont(ui.getFont());
		paramsList.setVisibleRowCount(4);
		paramsList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
			public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
				paramsListValueChanged(evt);
			}
		});

		jScrollPane3.setViewportView(paramsList);
		jPanel7.add(jScrollPane3, UIManager.getGridBagConstraints(1, 3, -1, -1, -1, -1, -1, GridBagConstraints.HORIZONTAL, null));

		jLabel3.setText(ui.getString("fina2.reportoo.name"));
		jLabel3.setFont(ui.getFont());
		jPanel7.add(jLabel3, UIManager.getGridBagConstraints(0, 0, -1, -1, -1, -1, GridBagConstraints.EAST, -1, new java.awt.Insets(0, 10, 5, 5)));

		paramNameText.setFont(ui.getFont());
		GridBagConstraints grid = UIManager.getGridBagConstraints(1, 0, -1, -1, -1, -1, -1, GridBagConstraints.HORIZONTAL, new java.awt.Insets(0, 0, 5, 0));
		grid.weightx = 1.0;
		jPanel7.add(paramNameText, grid);

		jLabel4.setText(ui.getString("fina2.description"));
		jLabel4.setFont(ui.getFont());
		jPanel7.add(jLabel4, UIManager.getGridBagConstraints(0, 2, -1, -1, -1, -1, GridBagConstraints.EAST, -1, new java.awt.Insets(0, 10, 5, 5)));

		paramDescriptionText.setFont(ui.getFont());
		jPanel7.add(paramDescriptionText, UIManager.getGridBagConstraints(1, 2, -1, -1, -1, -1, -1, GridBagConstraints.HORIZONTAL, new java.awt.Insets(0, 0, 5, 0)));

		jLabel8.setText(ui.getString("fina2.reportoo.parameterType"));
		jLabel8.setFont(ui.getFont());
		jPanel7.add(jLabel8, UIManager.getGridBagConstraints(0, 1, -1, -1, -1, -1, GridBagConstraints.EAST, -1, new java.awt.Insets(0, 10, 5, 5)));

		paramTypeCombo.setFont(ui.getFont());
		jPanel7.add(paramTypeCombo, UIManager.getGridBagConstraints(1, 1, -1, -1, -1, -1, GridBagConstraints.WEST, -1, new java.awt.Insets(0, 0, 5, 0)));

		jPanel4.add(jPanel7, java.awt.BorderLayout.CENTER);

		jPanel8.setLayout(new java.awt.BorderLayout());

		jPanel9.setLayout(new java.awt.GridBagLayout());

		newButton.setIcon(ui.getIcon("fina2.new"));
		newButton.setFont(ui.getFont());
		newButton.setText(ui.getString("fina2.new"));
		newButton.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
		newButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				newButtonActionPerformed(evt);
			}
		});
		jPanel9.add(newButton, UIManager.getGridBagConstraints(0, 0, -1, -1, -1, -1, -1, GridBagConstraints.HORIZONTAL, new java.awt.Insets(0, 10, 5, 3)));

		modifyButton.setIcon(ui.getIcon("fina2.modify"));
		modifyButton.setFont(ui.getFont());
		modifyButton.setText(ui.getString("fina2.modify"));
		modifyButton.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
		modifyButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				modifyButtonActionPerformed(evt);
			}
		});
		jPanel9.add(modifyButton, UIManager.getGridBagConstraints(0, 1, -1, -1, -1, -1, -1, GridBagConstraints.HORIZONTAL, new java.awt.Insets(0, 10, 5, 3)));

		deleteButton.setIcon(ui.getIcon("fina2.delete"));
		deleteButton.setFont(ui.getFont());
		deleteButton.setText(ui.getString("fina2.delete"));
		deleteButton.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
		deleteButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				deleteButtonActionPerformed(evt);
			}
		});
		jPanel9.add(deleteButton, UIManager.getGridBagConstraints(0, 2, -1, -1, -1, -1, -1, GridBagConstraints.HORIZONTAL, new java.awt.Insets(0, 10, 5, 3)));

		jPanel8.add(jPanel9, java.awt.BorderLayout.NORTH);

		jPanel4.add(jPanel8, java.awt.BorderLayout.EAST);

		jPanel14.add(jPanel4, java.awt.BorderLayout.CENTER);

		jPanel15.setLayout(new java.awt.GridBagLayout());

		jPanel15.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(10, 10, 5, 10)));
		jLabel6.setText(ui.getString("fina2.reportoo.formulaName"));
		jLabel6.setFont(ui.getFont());
		jPanel15.add(jLabel6, UIManager.getGridBagConstraints(0, 0, -1, -1, -1, -1, GridBagConstraints.EAST, -1, new java.awt.Insets(0, 0, 5, 5)));

		nameText.setFont(ui.getFont());
		GridBagConstraints grid1 = UIManager.getGridBagConstraints(1, 0, -1, -1, -1, -1, -1, GridBagConstraints.HORIZONTAL, new java.awt.Insets(0, 0, 5, 0));
		grid1.weightx = 1.0;
		jPanel15.add(nameText, grid1);

		jLabel7.setText(ui.getString("fina2.reportoo.formulaDescription"));
		jLabel7.setFont(ui.getFont());
		jPanel15.add(jLabel7, UIManager.getGridBagConstraints(0, 1, -1, -1, -1, -1, GridBagConstraints.NORTHEAST, -1, new java.awt.Insets(0, 0, 0, 5)));

		descriptionText.setRows(2);
		descriptionText.setFont(ui.getFont());
		jScrollPane5.setViewportView(descriptionText);
		jPanel15.add(jScrollPane5, UIManager.getGridBagConstraints(1, 1, -1, -1, GridBagConstraints.REMAINDER, -1, -1, GridBagConstraints.HORIZONTAL, null));

		jPanel14.add(jPanel15, java.awt.BorderLayout.NORTH);

		getContentPane().add(jPanel14, java.awt.BorderLayout.NORTH);

		pack();
	}// GEN-END:initComponents

	private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN-
		if (nameText.getText().trim().length() == 0) {
			ui.showMessageBox(null, ui.getString("fina2.title"), ui.getString("fina2.invalidnameEmpty"));
			return;
		}

		// event_okButtonActionPerformed
		ok = true;
		formula.setName(nameText.getText());
		formula.setDescription(descriptionText.getText());
		formula.setFormula(formulaText.getText());
		dispose();
	}// GEN-LAST:event_okButtonActionPerformed

	private void modifyButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN
		// -
		// FIRST
		// :
		// event_modifyButtonActionPerformed
		if (paramNameText.getText().trim().equals(""))
			return;
		if (paramsList.getSelectedIndex() == -1)
			return;

		Parameter p = (Parameter) paramsList.getSelectedValue();
		p.setName(paramNameText.getText());
		p.setDescription(paramDescriptionText.getText());
		p.setType(paramTypeCombo.getSelectedIndex());

		((javax.swing.DefaultListModel) paramsList.getModel()).setElementAt(p, paramsList.getSelectedIndex());
	}// GEN-LAST:event_modifyButtonActionPerformed

	private void deleteButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN
		// -
		// FIRST
		// :
		// event_deleteButtonActionPerformed
		if (paramsList.getSelectedIndex() == -1)
			return;

		parameters.remove(paramsList.getSelectedIndex());
		((javax.swing.DefaultListModel) paramsList.getModel()).remove(paramsList.getSelectedIndex());
	}// GEN-LAST:event_deleteButtonActionPerformed

	private void newButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN-
		// FIRST
		// :
		// event_newButtonActionPerformed
		if (paramNameText.getText().trim().equals(""))
			return;

		Parameter p = new Parameter(paramNameText.getText(), paramDescriptionText.getText(), paramTypeCombo.getSelectedIndex());
		parameters.add(p);
		((javax.swing.DefaultListModel) paramsList.getModel()).addElement(p);
		paramsList.setSelectedValue(p, true);
	}// GEN-LAST:event_newButtonActionPerformed

	private void paramsListValueChanged(javax.swing.event.ListSelectionEvent evt) {// GEN
		// -
		// FIRST
		// :
		// event_paramsListValueChanged
		int index = paramsList.getSelectedIndex();
		if (index != -1) {
			Parameter p = (Parameter) paramsList.getSelectedValue();
			paramNameText.setText(p.getName());
			paramDescriptionText.setText(p.getDescription());
			paramTypeCombo.setSelectedIndex(p.getType());
		} else {
			paramNameText.setText("");
			paramDescriptionText.setText("");
			paramTypeCombo.setSelectedIndex(0);
		}
	}// GEN-LAST:event_paramsListValueChanged

	private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN
		// -
		// FIRST
		// :
		// event_cancelButtonActionPerformed
		ok = false;
		dispose();
	}// GEN-LAST:event_cancelButtonActionPerformed

	/** Closes the dialog */
	private void closeDialog(java.awt.event.WindowEvent evt) {// GEN-FIRST:
		// event_closeDialog
		ok = false;
		setVisible(false);
		dispose();
	}// GEN-LAST:event_closeDialog

	/**
	 * @param args
	 *            the command line arguments
	 */
	public static void main(String args[]) {
		new FormulaAmendDialog(new javax.swing.JFrame(), true).show();
	}

	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JPanel jPanel5;
	private javax.swing.JScrollPane jScrollPane2;
	private javax.swing.JTextArea formulaText;
	private javax.swing.JPanel jPanel10;
	private javax.swing.JPanel jPanel12;
	private javax.swing.JButton helpButton;
	private javax.swing.JPanel jPanel13;
	private javax.swing.JButton okButton;
	private javax.swing.JButton cancelButton;
	private javax.swing.JPanel jPanel14;
	private javax.swing.JPanel jPanel4;
	private javax.swing.JPanel jPanel7;
	private javax.swing.JScrollPane jScrollPane3;
	private javax.swing.JList paramsList;
	private javax.swing.JLabel jLabel3;
	private javax.swing.JTextField paramNameText;
	private javax.swing.JLabel jLabel4;
	private javax.swing.JTextField paramDescriptionText;
	private javax.swing.JLabel jLabel8;
	private javax.swing.JComboBox paramTypeCombo;
	private javax.swing.JPanel jPanel8;
	private javax.swing.JPanel jPanel9;
	private javax.swing.JButton newButton;
	private javax.swing.JButton modifyButton;
	private javax.swing.JButton deleteButton;
	private javax.swing.JPanel jPanel15;
	private javax.swing.JLabel jLabel6;
	private javax.swing.JTextField nameText;
	private javax.swing.JLabel jLabel7;
	private javax.swing.JScrollPane jScrollPane5;
	private javax.swing.JTextArea descriptionText;
	// End of variables declaration//GEN-END:variables

}
